Bug 530850 - Feature: add support for Grave key as a toggle for Thai input
Feature: add support for Grave key as a toggle for Thai input
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: xkeyboard-config (Show other bugs)
rawhide
All Linux
low Severity low
: ---
: ---
Assigned To: Peter Hutterer
Fedora Extras Quality Assurance
: FutureFeature, MoveUpstream, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-25 12:09 EDT by Manatsawin Hanmongkolchai
Modified: 2012-07-23 22:00 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
: 619309 (view as bug list)
Environment:
Last Closed: 2012-07-23 22:00:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Manatsawin Hanmongkolchai 2009-10-25 12:09:36 EDT
Microsoft Windows offer Grave Accent (`) as one of the buttons that can be used to change input method. This option only present if every Regional & Language Options settings are set to Thai.

New users moving from Linux are having habit of press the ` key to switch layout (It's de facto standard here) so Thai Linux communities (namely OpenTLE and Ubuntuclub) have created a deb that add Grave to one of the choices.

The deb in question is available from http://mirror.nytes.net/linux/clubuntu/Packages/xkb-data-grave.deb

I suggest that we should provide this out of the box but not the default one. I have studied the deb and found that these files are changed (line number and file path is as of xkeyboard-config 1.6-3.fc12)

/usr/share/X11/xkb/rules/:

- ./base line 941 AND ./evdev line 883	APPEND
  grp:grave_switch      =	+group(grave_switch)
- ./base.lst AND ./evdev.lst line 610	APPEND
  grp:grave_switch     Grave (~)
- ./evdev.xml and ./base.xml line 4280 APPEND
      <option>
        <configItem>
          <name>grp:grave_switch</name>
          <description>Grave (~)</description>
        </configItem>
      </option>

(Note that Microsoft Windows labeled it as "Grave Accent" but most end user are know it as the tilde (~))

In short: Thailand use grave as de facto standard for layout switching thus we need to add it into the list of available layout switching options.

Of course, I don't expect this to be the default option.



If possible, super+grave should print out ` and shift+grave should print out ~. Above patch will ignore the modifier key and switch layout. (Both tricks only work in Microsoft Windows earlier than Vista)
Comment 2 Matěj Cepl 2009-11-05 12:19:08 EST
Since this bugzilla report was filed, there have been several major updates in various components of the Xorg system, which may have resolved this issue. Users who have experienced this problem are encouraged to upgrade their system to the latest version of their packages (at least F12Beta, but even better if the very latest versions).

Please, if you experience this problem on the up-to-date system, let us now in the comment for this bug, or whether the upgraded system works for you.

If you won't be able to reply in one month, I will have to close this bug as INSUFFICIENT_DATA. Thank you.

[This is a bulk message for all open Fedora Rawhide Xorg-related bugs. I'm adding myself to the CC list for each bug, so I'll see any comments you make after this and do my best to make sure every issue gets proper attention.]
Comment 3 Manatsawin Hanmongkolchai 2009-11-06 05:39:26 EST
Clearing needinfo. This is feature request, not a bug.
Comment 4 Chris Campbell 2009-11-08 12:32:37 EST
Adding FutureFeature keyword

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 5 Peter Hutterer 2009-11-19 22:23:25 EST
Manatsawin: are we talking about input method switching or layout switching here? I'm not sure about this from the first comment which hints at IM first, but layout later.
Comment 6 Jens Petersen 2009-11-19 22:29:30 EST
In that context; just curious if you have tried/use Thai input
with ibus-m17n and m17n-db-thai?
Comment 7 Manatsawin Hanmongkolchai 2009-11-20 03:21:45 EST
I'm talking about xim method switching. (The one that can be setup at GNOME's Keyboard Setting)

I tried IBus, it can use grave as one of the toggle key but the way IBus enter Thai character isn't what Thais use. (In IBus I have to type next character before it write the last character into the input box. Other OS use XIM-like method: type everything into the input box)
Comment 8 Peter Hutterer 2010-01-14 22:22:01 EST
reassigning to ibus
Comment 9 Jens Petersen 2010-01-20 00:55:22 EST
(In reply to comment #7)
> I'm talking about xim method switching. (The one that can be setup at GNOME's
> Keyboard Setting)

That is not XIM but xkb.

> I tried IBus, it can use grave as one of the toggle key but the way IBus enter
> Thai character isn't what Thais use. (In IBus I have to type next character
> before it write the last character into the input box. Other OS use XIM-like
> method: type everything into the input box)    

Can you please tell us exactly what you tested so we can improve it.
Comment 10 Manatsawin Hanmongkolchai 2010-01-20 03:41:57 EST
"Traditional" Thai input is to input like English: everything into the input box.
IBus Thai Input use a small box to type in base character + vowels before put it into the input box.

Like when you type ที่วันนี้ the IBus input box will show "ที่" "วั" "น" "นี้" while traditional way is type the entire string as-is into the box.
Comment 11 Jens Petersen 2010-01-20 05:01:52 EST
Yes I understand it is using pre-edit.

I need to know when exact input map you used to input Thai?

One of these:

/usr/share/m17n/th-kesmanee.mim
/usr/share/m17n/th-pattachote.mim
/usr/share/m17n/th-tis820.mim

?
Comment 12 Manatsawin Hanmongkolchai 2010-01-20 06:00:11 EST
In end user's perspective th-tis820, th-kesmanee have no visible difference so they might select one as they wish.

th-pattachote is much like Dvorak keyboard: not much used (but still used and types faster
Comment 13 Jens Petersen 2010-01-20 19:13:50 EST
So what is the layout you prefer - ie what layout is offered by xkb?
Comment 14 Manatsawin Hanmongkolchai 2010-01-21 03:38:29 EST
in my GNOME keyboard preferences (which should be from XKB) "Thailand" input method (which we preferred) is th-kedmanee. also pattachote and tis-820 is offered.
Comment 15 Jens Petersen 2010-01-22 04:49:43 EST
I see: perhaps Kedmanee should be ported to m17n-contrib.
Comment 16 Jens Petersen 2010-07-29 04:38:05 EDT
Sorry for long pause.

You need to provide clearer information so we can help:
ie to describe the exact steps (install, login, application,
input etc).

Seems you are actually talking about Xkb not XIM.

(In reply to comment #0)
> The deb in question is available from
> http://mirror.nytes.net/linux/clubuntu/Packages/xkb-data-grave.deb

This would be xkeyboard-config and your patch should be submitted upstream.
See http://www.freedesktop.org/wiki/Software/XKeyboardConfig
Comment 17 Jens Petersen 2010-07-29 05:00:27 EDT
I filed bug 619309 for:

(In reply to comment #10)
> IBus Thai Input use a small box to type in base character + vowels before put
> it into the input box.
> 
> Like when you type ที่วันนี้ the IBus input box will show "ที่" "วั" "น" "นี้"
> while traditional way is type the entire string as-is into the box.
Comment 18 Peter Hutterer 2010-11-02 20:15:20 EDT
scratch build available here, is that about what you wanted?
http://koji.fedoraproject.org/koji/taskinfo?taskID=2573007
(this is a rawhide scratch build but it should just work with any recent fedora version)

activate with "setxkbmap -option "grp:grave_toggle" or by clicking the matching checkbox in the UI
Comment 19 Peter Hutterer 2012-07-23 22:00:25 EDT
needinfo for nearly 2 years, closing.

Note You need to log in before you can comment on or make changes to this bug.